library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

package malib is

constant black : std_logic_vector(2 downto 0) := "000";
constant blue : std_logic_vector(2 downto 0) := "001";
constant green  : std_logic_vector(2 downto 0) := "010";
constant cyan : std_logic_vector(2 downto 0) := "011";
constant red : std_logic_vector(2 downto 0) := "100";
constant magenta : std_logic_vector(2 downto 0) := "101";
constant yellow : std_logic_vector(2 downto 0) := "110";
constant white : std_logic_vector(2 downto 0) := "111";


component vga_synchro is port (
    clk,init : in std_logic;
    hsynch,vsynch,video_on : out std_logic;
    pixel_x,pixel_y : out std_logic_vector(9 downto 0)
    );
end component;

component rec is port (
	pixel_x,pixel_y : in std_logic_vector(9 downto 0);
	video_on,onoff : in  std_logic;
	x,dx,y,dy: in std_logic_vector(9 downto 0);
	coloron,coloroff : in std_logic_vector(2 downto 0);
	rgb : out std_logic_vector(2 downto 0)
	);
end component;

component bord is port (
	pixel_x,pixel_y : in std_logic_vector(9 downto 0);
	video_on,onoff : in  std_logic;
	--x,y: in std_logic_vector(9 downto 0);
	coloron,coloroff : in std_logic_vector(2 downto 0);
	rgb : out std_logic_vector(2 downto 0)
	);
end component;

component dds is port (
	clk : in std_logic;
	dn : in std_logic_vector(31 downto 0);
	clkout : out std_logic );
end component;

--component balle is port (
--	pixel_x,pixel_y : in std_logic_vector(9 downto 0);
--	video_on,onoff : in  std_logic;
--	x,dx,y,dy: in std_logic_vector(9 downto 0);
--	coloron,coloroff : in std_logic_vector(2 downto 0);
--	rgb : out std_logic_vector(2 downto 0)
--	);
--end component;

end package;


--library ieee;
--use ieee.std_logic_1164.all;
--use ieee.std_logic_arith.all;
--use ieee.std_logic_unsigned.all;
--
--entity balle is port (
--	pixel_x,pixel_y : in std_logic_vector(9 downto 0);
--	video_on,onoff : in  std_logic;
--	x,dx,y,dy: in std_logic_vector(9 downto 0);
--	coloron,coloroff : in std_logic_vector(2 downto 0);
--	rgb : out std_logic_vector(2 downto 0)
--	);
--end entity;
--
--architecture behavior of balle is 
--
--begin
--
--
--
--end behavior;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;


entity dds is port (
	clk : in std_logic;
	dn : in std_logic_vector(31 downto 0);
	clkout : out std_logic );
end entity;

architecture behavior of dds is 
signal a,b,c : std_logic_vector(31 downto 0);
signal d : std_logic;
begin
process(clk) begin
	if rising_edge(clk) then
		a <= c;
		b <= dn;
	end if;
end process;

process(clk) begin
	if rising_edge(clk) then
		if a(31)='1' then
			d <= not d;
		end if;
	end if;
end process;

clkout <= d;

c <= ('0' & a(30 downto 0) ) + ( '0' & b(30 downto 0) );
end behavior;



library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;


entity bord is port (
	pixel_x,pixel_y : in std_logic_vector(9 downto 0);
	video_on,onoff : in  std_logic;
	--x,y: in std_logic_vector(9 downto 0);
	coloron,coloroff : in std_logic_vector(2 downto 0);
	rgb : out std_logic_vector(2 downto 0)
	);
end entity;


architecture behavior of bord is 

constant black : std_logic_vector(2 downto 0) := "000";
constant blue : std_logic_vector(2 downto 0) := "001";
constant green  : std_logic_vector(2 downto 0) := "010";
constant cyan : std_logic_vector(2 downto 0) := "011";
constant red : std_logic_vector(2 downto 0) := "100";
constant magenta : std_logic_vector(2 downto 0) := "101";
constant yellow : std_logic_vector(2 downto 0) := "110";
constant white : std_logic_vector(2 downto 0) := "111";

constant colorfond : std_logic_vector(2 downto 0) := black;


-- process rectangle gauche

begin 
process (pixel_x, pixel_y, video_on) begin
	if video_on = '1' then
		if ( (pixel_x = 1 and pixel_y < 480)   or
				(pixel_x = 639 and pixel_y < 480) or
				(pixel_x <640 and pixel_y =0) or
				(pixel_x <640 and pixel_y = 479) )
		then
			if onoff ='1' then 
				rgb <= coloron;
			else 
				rgb <= coloroff;
			end if;
		else 
			rgb <= coloroff;
		end if;
	else
		rgb <= black;
	end if;
end process; 

end behavior;


library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;


entity rec is port (
	pixel_x,pixel_y : in std_logic_vector(9 downto 0);
	video_on,onoff : in  std_logic;
	x,dx,y,dy: in std_logic_vector(9 downto 0);
	coloron,coloroff : in std_logic_vector(2 downto 0);
	rgb : out std_logic_vector(2 downto 0)
	);
end entity;


architecture behavior of rec is 

constant black : std_logic_vector(2 downto 0) := "000";
constant blue : std_logic_vector(2 downto 0) := "001";
constant green  : std_logic_vector(2 downto 0) := "010";
constant cyan : std_logic_vector(2 downto 0) := "011";
constant red : std_logic_vector(2 downto 0) := "100";
constant magenta : std_logic_vector(2 downto 0) := "101";
constant yellow : std_logic_vector(2 downto 0) := "110";
constant white : std_logic_vector(2 downto 0) := "111";

constant colorfond : std_logic_vector(2 downto 0) := black;


-- process rectangle gauche

begin 


process(pixel_x,pixel_y,video_on,x,dx,y,dy)begin
    if video_on='1' then
        if ( pixel_x > x and pixel_x < (x+dx)  --longueur de la raquette 
            and pixel_y > y and pixel_y < (y+dy) ) then
            if onoff ='1' then
					rgb <= coloron;
				else
					rgb <= coloroff;
				end if;
		  else 
				rgb <=  colorfond;
		  end if;
		else 
				rgb <= black;
		end if;
end process;
end behavior;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity vga_synchro is port (
    clk,init : in std_logic;
    hsynch,vsynch,video_on : out std_logic;
    pixel_x,pixel_y : out std_logic_vector(9 downto 0)
    );
end entity;

architecture behavior of vga_synchro is
    signal hcntreg,vcntreg,hcntnext,vcntnext: std_logic_vector(9 downto 0);
    signal envreg,envnext,hsynchreg,hsynchnext,vsynchreg,vsynchnext : std_logic;
    signal videoonnext,videoonreg : std_logic;
    
begin

-- process synchrone
    process(clk,init) begin
   	 if init='1' then
   		 hcntreg    <= (others=>'0');
   		 vcntreg    <= (others=>'0');
   		 envreg    <= '0';
   		 hsynchreg    <= '1';
   		 vsynchreg    <= '1';
   		 videoonreg    <= '0';
   	 elsif rising_edge(clk) then
   		 hcntreg    <= hcntnext;
   		 if envreg='1' then   							 
   			 vcntreg    <= vcntnext;
   		 end if;
   		 envreg    <= envnext;
   		 hsynchreg    <= hsynchnext;
   		 vsynchreg    <= vsynchnext;
   		 videoonreg    <= videoonnext;
   	 end if;
    end process;
    
-- process asynchrone
    process(hcntreg) begin
   	 if hcntreg<799 then
   		 hcntnext    <= hcntreg+1;
   		 envnext <= '0';
   	 else
   		 hcntnext    <= (others=>'0');
   		 envnext <= '1';
   	 end if;
   	 if (hcntreg>655 and hcntreg<753) then
   		 hsynchnext <= '0';
   	 else
   		 hsynchnext <= '1';
   	 end if;
    end process;
    
    process(vcntreg) begin
   	 if vcntreg<519 then
   		 vcntnext <= vcntreg + 1;
   	 else
   		 vcntnext    <= (others => '0');
   	 end if;
   	 if(vcntreg>489 and vcntreg<492) then
   		 vsynchnext <= '0';
   	 else
   		 vsynchnext <= '1';
   	 end if;
    end process;

--    process(hcntreg) begin
--   	 if hcntreg < 799 then
--   		 envnext <= '0';
--   	 else
--   		 envnext <= '1';
--   	 end if;
--    end process;
--
--    process(hcntreg) begin
--   	 if (hcntreg>655 and hcntreg<753) then
--   		 hsynchnext <= '0';
--   	 else
--   		 hsynchnext <= '1';
--   	 end if;
--    end process;


    process(hcntreg,vcntreg) begin
   	 if (hcntreg<640 and vcntreg<480) then
   		 videoonnext <= '1';
   	 else
   		 videoonnext <= '0';
   	 end if;
    end process;
    
    pixel_x    <= hcntreg;
    pixel_y    <=    vcntreg;
    hsynch    <=    hsynchreg;
    vsynch    <=    vsynchreg;
    video_on    <=    videoonreg;
   		 
end behavior;


